from time import ticks_ms
from machine import Pin
import config as cfg
from tools import Util

# ToDo: Class per game or a common game class ?
class RandRing:
    """
    Shot random rings, one after the other
    Total time counts
    """
    def __init__(self, npx):
        self.npx = npx
        self.util = Util(npx)
        self.hitwait_startticks = 0

    def game(self):
        target_led_start = Pin(cfg.TargetLedPins[cfg.START_TARGET], Pin.IN)
        while True:
            print(20, "Game:  -- RandRing --")
            color_key, color_value = self.util.random_color()
            self.util.shootsignal(True)  # ready to shoot
            self.hitwait_startticks = ticks_ms()
            print(24, "Wait for a START hit")

            if self.util.wait_for_hit(target_led_start, self.hitwait_startticks, cfg.TimeDef["MasterTimeout"]):
                print(27, cfg.START_TARGET, "! Hit ! ")
                self.util.shootsignal(False)
                cfg.DynHtmlData["Ticks"] = "0.0"
            else:
                print(31, "Timeout ")
                self.hitwait_startticks = cfg.TimeDef["TimeoutTag"]
                break
            # target_numbers = self.util.randint32(6, nozero=True)
            target_numbers = cfg.RandRing['Rings2Shoot']
            self.hitwait_startticks = ticks_ms()
            target_count = 0
            while target_count < target_numbers:
                target_name, target_value = self.util.random_target_ring()
                target_led = Pin(cfg.TargetLedPins[target_name], Pin.IN)
                self.npx.npix_LEDstripe(segment=cfg.TargetRings[target_name], rgbcolor=color_value,
                                        ledsequence=3)  # target color = master color
                print(43, target_name, " Wait for a hit", color_value)
                if self.util.wait_for_hit(target_led, self.hitwait_startticks, cfg.TimeDef["MasterTimeout"]):
                    print(45, target_name, "! Target Hit !")
                else:
                    print(47, "Timeout")
                    self.hitwait_startticks = cfg.TimeDef["TimeoutTag"]
                    break
                target_count += 1
            break
        return self.hitwait_startticks

    def run(self):
        return self.game()

class ColPatt:
    pass

class RunPosi:
    pass