import network
import socket as socket
import config as cfg

from html_pages import Pages as html

class WebSocket:
    def __init__(self):
        self.html = html().game()

    def web_page(self, html):
        """Replace dict items of DynHtmlData in the html string"""
        html_static, html_dynamic = html
        fd = html_dynamic.format(**cfg.DynHtmlData)
        html = html_static + fd
        return html

    def evaluation(self, request):
        """
        Find and return ID in  in the HTTP string of the browser request
            GET /?act=xx HTTP/1.1\r........
        act: keyword, xx: id
        """
        posi = request.find('act')  # find keyword position
        if posi == -1:
            return cfg.ERROR
        return request[posi + 4: posi+6]

    def send_response(self, con, data):
        con.sendall(self.web_page(data))
        con.close()

    def run_server(self, sock, html, html2=None):
        while True:
            try:
                con, addr = sock.accept()
                print(34, 'Connected to: ', str(addr))
                con.settimeout(10.0)
                request = str(con.recv(516))
                print(37, request[:25])
            except Exception as e:
                print(39, "Websocket exception", e)
                return cfg.ERROR
            else:
                # request -> response -> return
                if html is not None and html2 is None:
                    act = self.evaluation(request)
                    self.send_response(con, html)
                    return act
                # show selection screen and wait for a user input
                if html is not None and html2 is not None:
                    self.send_response(con, html)
                    html = None
                    continue

                # get user input and show result screen ( poll)
                if html is None:
                    act = self.evaluation(request)
                    self.send_response(con, html2)
                    return act

    def setup_network(self):
        ap = network.WLAN(network.AP_IF)  # Access point
        ap.active(True)
        ap.config(essid=cfg.ESP8266_WLAN["SSID"], password=cfg.ESP8266_WLAN["Password"])

        while ap.active() == False: # timeout?
            pass
        print(69,"WLAN connected ", ap.ifconfig())

    def setup_server_socket(self):
        sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        sock.bind(('', cfg.ESP8266_WLAN["Port"]))
        sock.listen(1)
        return sock
